# coding: utf-8

# flake8: noqa

"""
    Eazyrent core API

    EazyRent Core API ====================  Description -------------  The EazyRent API is a powerful tool, designed to automate and streamline the tenant application process for professionals in the real estate and insurance sectors.  Our API leverages advanced technologies like Optical Character Recognition (OCR) and Machine Learning to collect, analyze, and verify tenant application documents.  The API helps clients detect fraudulent submissions and assess the reliability of potential tenants, ensuring a secure and efficient tenant selection process.  Target Audience ----------------   * **Real Estate Agencies and Social Housing Providers:** Professionals who need a reliable solution to evaluate tenant applications quickly and accurately.   * **Rent Guarantee Insurers:** Companies seeking to verify the credibility of tenant applications and assess eligibility for rent payment guarantees.   Purpose --------  The purpose of the EazyRent API is to enable seamless interaction with our tenant application system. It allows clients to integrate our automated document collection, analysis, and verification capabilities directly into their own workflows. By using our API, businesses can streamline operations, reduce fraud risk, and make well-informed decisions in the tenant selection process.   How to use this API ---------------------  To start using the EazyRent API, please refer to our comprehensive online documentation, which includes detailed information on API endpoints, authentication, and integration examples. You can access the documentation [here](https://docs.eazyrent.fr). This resource will guide you through the steps needed to integrate our API into your existing systems and maximize its capabilities.  

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from eazyrent.core.v1.api.accepted_supporting_documents_api import (
    AcceptedSupportingDocumentsApi,
)
from eazyrent.core.v1.api.applicant_files_api import ApplicantFilesApi
from eazyrent.core.v1.api.applicants_api import ApplicantsApi
from eazyrent.core.v1.api.physical_guarantors_api import PhysicalGuarantorsApi
from eazyrent.core.v1.api.rents_api import RentsApi
from eazyrent.core.v1.api.supporting_documents_api import SupportingDocumentsApi
from eazyrent.core.v1.api.users_api import UsersApi

# import ApiClient
from eazyrent.core.v1.api_response import ApiResponse
from eazyrent.core.v1.api_client import ApiClient
from eazyrent.core.v1.configuration import Configuration
from eazyrent.core.v1.exceptions import OpenApiException
from eazyrent.core.v1.exceptions import ApiTypeError
from eazyrent.core.v1.exceptions import ApiValueError
from eazyrent.core.v1.exceptions import ApiKeyError
from eazyrent.core.v1.exceptions import ApiAttributeError
from eazyrent.core.v1.exceptions import ApiException

# import models into sdk package
from eazyrent.core.v1.models.accepted_supporting_document import (
    AcceptedSupportingDocument,
)
from eazyrent.core.v1.models.alert_pretty import AlertPretty
from eazyrent.core.v1.models.apis_core_schemas_v1_applicants_physical_guarantor import (
    ApisCoreSchemasV1ApplicantsPhysicalGuarantor,
)
from eazyrent.core.v1.models.apis_core_schemas_v1_physical_guarantors_physical_guarantor import (
    ApisCoreSchemasV1PhysicalGuarantorsPhysicalGuarantor,
)
from eazyrent.core.v1.models.applicant import Applicant
from eazyrent.core.v1.models.applicant_light import ApplicantLight
from eazyrent.core.v1.models.applicant_list import ApplicantList
from eazyrent.core.v1.models.applicants_situation_enum import ApplicantsSituationEnum
from eazyrent.core.v1.models.company import Company
from eazyrent.core.v1.models.company_config import CompanyConfig
from eazyrent.core.v1.models.create_applicant import CreateApplicant
from eazyrent.core.v1.models.format_enum import FormatEnum
from eazyrent.core.v1.models.http_validation_error import HTTPValidationError
from eazyrent.core.v1.models.id import Id
from eazyrent.core.v1.models.light_upload_file import LightUploadFile
from eazyrent.core.v1.models.next import Next
from eazyrent.core.v1.models.paginated_response_accepted_supporting_document import (
    PaginatedResponseAcceptedSupportingDocument,
)
from eazyrent.core.v1.models.paginated_response_applicant_list import (
    PaginatedResponseApplicantList,
)
from eazyrent.core.v1.models.paginated_response_physical_guarantor import (
    PaginatedResponsePhysicalGuarantor,
)
from eazyrent.core.v1.models.paginated_response_property_rent_list import (
    PaginatedResponsePropertyRentList,
)
from eazyrent.core.v1.models.paginated_response_rental_file_full import (
    PaginatedResponseRentalFileFull,
)
from eazyrent.core.v1.models.paginated_response_rental_file_list import (
    PaginatedResponseRentalFileList,
)
from eazyrent.core.v1.models.paginated_response_supporting_document_list import (
    PaginatedResponseSupportingDocumentList,
)
from eazyrent.core.v1.models.physical_guarantor_create import PhysicalGuarantorCreate
from eazyrent.core.v1.models.previous import Previous
from eazyrent.core.v1.models.property_rent import PropertyRent
from eazyrent.core.v1.models.property_rent_create import PropertyRentCreate
from eazyrent.core.v1.models.property_rent_list import PropertyRentList
from eazyrent.core.v1.models.property_rent_partial_update import (
    PropertyRentPartialUpdate,
)
from eazyrent.core.v1.models.reject_reason_enum import RejectReasonEnum
from eazyrent.core.v1.models.rent_partial_update import RentPartialUpdate
from eazyrent.core.v1.models.rent_update import RentUpdate
from eazyrent.core.v1.models.rental_file import RentalFile
from eazyrent.core.v1.models.rental_file_create import RentalFileCreate
from eazyrent.core.v1.models.rental_file_full import RentalFileFull
from eazyrent.core.v1.models.rental_file_list import RentalFileList
from eazyrent.core.v1.models.rental_file_partial_update import RentalFilePartialUpdate
from eazyrent.core.v1.models.status6d0_enum import Status6d0Enum
from eazyrent.core.v1.models.status_b55_enum import StatusB55Enum
from eazyrent.core.v1.models.status_d7b_enum import StatusD7bEnum
from eazyrent.core.v1.models.status_e9d_enum import StatusE9dEnum
from eazyrent.core.v1.models.supporting_document import SupportingDocument
from eazyrent.core.v1.models.supporting_document_list import SupportingDocumentList
from eazyrent.core.v1.models.user import User
from eazyrent.core.v1.models.validation_error import ValidationError
from eazyrent.core.v1.models.validation_error_loc_inner import ValidationErrorLocInner
