# coding: utf-8

"""
    Eazyrent core API

    EazyRent Core API ====================  Description -------------  The EazyRent API is a powerful tool, designed to automate and streamline the tenant application process for professionals in the real estate and insurance sectors.  Our API leverages advanced technologies like Optical Character Recognition (OCR) and Machine Learning to collect, analyze, and verify tenant application documents.  The API helps clients detect fraudulent submissions and assess the reliability of potential tenants, ensuring a secure and efficient tenant selection process.  Target Audience ----------------   * **Real Estate Agencies and Social Housing Providers:** Professionals who need a reliable solution to evaluate tenant applications quickly and accurately.   * **Rent Guarantee Insurers:** Companies seeking to verify the credibility of tenant applications and assess eligibility for rent payment guarantees.   Purpose --------  The purpose of the EazyRent API is to enable seamless interaction with our tenant application system. It allows clients to integrate our automated document collection, analysis, and verification capabilities directly into their own workflows. By using our API, businesses can streamline operations, reduce fraud risk, and make well-informed decisions in the tenant selection process.   How to use this API ---------------------  To start using the EazyRent API, please refer to our comprehensive online documentation, which includes detailed information on API endpoints, authentication, and integration examples. You can access the documentation [here](https://docs.eazyrent.fr). This resource will guide you through the steps needed to integrate our API into your existing systems and maximize its capabilities.  

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from eazyrent.core.v1.api.applicant_files_api import ApplicantFilesApi


class TestApplicantFilesApi(unittest.TestCase):
    """ApplicantFilesApi unit test stubs"""

    def setUp(self) -> None:
        self.api = ApplicantFilesApi()

    def tearDown(self) -> None:
        pass

    def test_create_applicant_files(self) -> None:
        """Test case for create_applicant_files

        Create applicant files
        """
        pass

    def test_delete_applicant_file(self) -> None:
        """Test case for delete_applicant_file

        Delete applicant file
        """
        pass

    def test_get_applicant_file(self) -> None:
        """Test case for get_applicant_file

        Get applicant file
        """
        pass

    def test_list_applicant_files(self) -> None:
        """Test case for list_applicant_files

        List applicant files
        """
        pass

    def test_list_full_rental_files(self) -> None:
        """Test case for list_full_rental_files

        List full rental files
        """
        pass

    def test_partial_update_applicant_file(self) -> None:
        """Test case for partial_update_applicant_file

        Partial update applicant file
        """
        pass

    def test_update_applicant_file(self) -> None:
        """Test case for update_applicant_file

        Update applicant file
        """
        pass


if __name__ == "__main__":
    unittest.main()
