# coding: utf-8

# flake8: noqa

"""
    Eazyrent core API

    EazyRent Core API ====================  Description -------------  The EazyRent API is a powerful tool, designed to automate and streamline the tenant application process for professionals in the real estate and insurance sectors.  Our API leverages advanced technologies like Optical Character Recognition (OCR) and Machine Learning to collect, analyze, and verify tenant application documents.  The API helps clients detect fraudulent submissions and assess the reliability of potential tenants, ensuring a secure and efficient tenant selection process.  Target Audience ----------------   * **Real Estate Agencies and Social Housing Providers:** Professionals who need a reliable solution to evaluate tenant applications quickly and accurately.   * **Rent Guarantee Insurers:** Companies seeking to verify the credibility of tenant applications and assess eligibility for rent payment guarantees.   Purpose --------  The purpose of the EazyRent API is to enable seamless interaction with our tenant application system. It allows clients to integrate our automated document collection, analysis, and verification capabilities directly into their own workflows. By using our API, businesses can streamline operations, reduce fraud risk, and make well-informed decisions in the tenant selection process.   How to use this API ---------------------  To start using the EazyRent API, please refer to our comprehensive online documentation, which includes detailed information on API endpoints, authentication, and integration examples. You can access the documentation [here](https://docs.eazyrent.fr). This resource will guide you through the steps needed to integrate our API into your existing systems and maximize its capabilities.  

    The version of the OpenAPI document: 2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from eazyrent.core.v2.api.accepted_documents_api import AcceptedDocumentsApi
from eazyrent.core.v2.api.applicant_forms_api import ApplicantFormsApi
from eazyrent.core.v2.api.documents_api import DocumentsApi
from eazyrent.core.v2.api.rental_files_api import RentalFilesApi
from eazyrent.core.v2.api.rental_files_comments_api import RentalFilesCommentsApi
from eazyrent.core.v2.api.share_links_api import ShareLinksApi
from eazyrent.core.v2.api.tags_api import TagsApi

# import ApiClient
from eazyrent.core.v2.api_response import ApiResponse
from eazyrent.core.v2.api_client import ApiClient
from eazyrent.core.v2.configuration import Configuration
from eazyrent.core.v2.exceptions import OpenApiException
from eazyrent.core.v2.exceptions import ApiTypeError
from eazyrent.core.v2.exceptions import ApiValueError
from eazyrent.core.v2.exceptions import ApiKeyError
from eazyrent.core.v2.exceptions import ApiAttributeError
from eazyrent.core.v2.exceptions import ApiException

# import models into sdk package
from eazyrent.core.v2.models.accepted_document import AcceptedDocument
from eazyrent.core.v2.models.alert import Alert
from eazyrent.core.v2.models.applicant import Applicant
from eazyrent.core.v2.models.base_alert_type import BaseAlertType
from eazyrent.core.v2.models.close_rental_file import CloseRentalFile
from eazyrent.core.v2.models.create_accepted_document import CreateAcceptedDocument
from eazyrent.core.v2.models.create_applicant import CreateApplicant
from eazyrent.core.v2.models.create_rental_file import CreateRentalFile
from eazyrent.core.v2.models.document_slice import DocumentSlice
from eazyrent.core.v2.models.document_type import DocumentType
from eazyrent.core.v2.models.document_view import DocumentView
from eazyrent.core.v2.models.file import File
from eazyrent.core.v2.models.form_comment import FormComment
from eazyrent.core.v2.models.http_validation_error import HTTPValidationError
from eazyrent.core.v2.models.history_event import HistoryEvent
from eazyrent.core.v2.models.images import Images
from eazyrent.core.v2.models.invite_payload import InvitePayload
from eazyrent.core.v2.models.list_accepted_document import ListAcceptedDocument
from eazyrent.core.v2.models.list_applicant import ListApplicant
from eazyrent.core.v2.models.list_document import ListDocument
from eazyrent.core.v2.models.list_products_projection import ListProductsProjection
from eazyrent.core.v2.models.list_rental_file import ListRentalFile
from eazyrent.core.v2.models.managers_eq import ManagersEq
from eazyrent.core.v2.models.moral_guarantor import MoralGuarantor
from eazyrent.core.v2.models.next import Next
from eazyrent.core.v2.models.paginated_response_document_view import (
    PaginatedResponseDocumentView,
)
from eazyrent.core.v2.models.paginated_response_list_accepted_document import (
    PaginatedResponseListAcceptedDocument,
)
from eazyrent.core.v2.models.paginated_response_list_rental_file import (
    PaginatedResponseListRentalFile,
)
from eazyrent.core.v2.models.partial_update_accepted_document import (
    PartialUpdateAcceptedDocument,
)
from eazyrent.core.v2.models.partial_update_rental_file import PartialUpdateRentalFile
from eazyrent.core.v2.models.previous import Previous
from eazyrent.core.v2.models.product_photo import ProductPhoto
from eazyrent.core.v2.models.product_type import ProductType
from eazyrent.core.v2.models.reject_reason import RejectReason
from eazyrent.core.v2.models.rental_file import RentalFile
from eazyrent.core.v2.models.rental_file_comment import RentalFileComment
from eazyrent.core.v2.models.rental_file_comment_in import RentalFileCommentIn
from eazyrent.core.v2.models.rental_file_status import RentalFileStatus
from eazyrent.core.v2.models.reopen_forms import ReopenForms
from eazyrent.core.v2.models.tag import Tag
from eazyrent.core.v2.models.tag_in import TagIn
from eazyrent.core.v2.models.thumbnail import Thumbnail
from eazyrent.core.v2.models.to_download import ToDownload
from eazyrent.core.v2.models.update_accepted_document import UpdateAcceptedDocument
from eazyrent.core.v2.models.update_applicant import UpdateApplicant
from eazyrent.core.v2.models.update_rental_file import UpdateRentalFile
from eazyrent.core.v2.models.validation_error import ValidationError
from eazyrent.core.v2.models.validation_error_loc_inner import ValidationErrorLocInner
