# coding: utf-8

"""
    Eazyrent core API

    EazyRent Core API ====================  Description -------------  The EazyRent API is a powerful tool, designed to automate and streamline the tenant application process for professionals in the real estate and insurance sectors.  Our API leverages advanced technologies like Optical Character Recognition (OCR) and Machine Learning to collect, analyze, and verify tenant application documents.  The API helps clients detect fraudulent submissions and assess the reliability of potential tenants, ensuring a secure and efficient tenant selection process.  Target Audience ----------------   * **Real Estate Agencies and Social Housing Providers:** Professionals who need a reliable solution to evaluate tenant applications quickly and accurately.   * **Rent Guarantee Insurers:** Companies seeking to verify the credibility of tenant applications and assess eligibility for rent payment guarantees.   Purpose --------  The purpose of the EazyRent API is to enable seamless interaction with our tenant application system. It allows clients to integrate our automated document collection, analysis, and verification capabilities directly into their own workflows. By using our API, businesses can streamline operations, reduce fraud risk, and make well-informed decisions in the tenant selection process.   How to use this API ---------------------  To start using the EazyRent API, please refer to our comprehensive online documentation, which includes detailed information on API endpoints, authentication, and integration examples. You can access the documentation [here](https://docs.eazyrent.fr). This resource will guide you through the steps needed to integrate our API into your existing systems and maximize its capabilities.  

    The version of the OpenAPI document: 2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from eazyrent.core.v2.models.list_rental_file import ListRentalFile


class TestListRentalFile(unittest.TestCase):
    """ListRentalFile unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> ListRentalFile:
        """Test ListRentalFile
        include_optional is a boolean, when False only required
        params are included, when True both required and
        optional params are included"""
        # uncomment below to create an instance of `ListRentalFile`
        """
        model = ListRentalFile()
        if include_optional:
            return ListRentalFile(
                product_id = '',
                meta = None,
                allow_user_engagement = True,
                id = '',
                status = 'NEW',
                applicants_situation = 'SINGLE',
                archived_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'),
                tags = [
                    core.v2.models.tag.Tag(
                        tenant = '', 
                        name = '', )
                    ],
                managers = [
                    ''
                    ],
                created_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'),
                updated_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'),
                score = 1.337,
                completion_rate = 1.337,
                applicants = [
                    core.v2.models.list_applicant.ListApplicant(
                        first_name = '', 
                        last_name = '', 
                        email = '', 
                        phone = '', 
                        id = '', 
                        status = 'NEW', 
                        form_submitted = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        score = 1.337, 
                        created_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        updated_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        is_guarantor = True, 
                        physical_guarantors = [
                            core.v2.models.list_applicant.ListApplicant(
                                first_name = '', 
                                last_name = '', 
                                email = '', 
                                phone = '', 
                                id = '', 
                                status = 'NEW', 
                                form_submitted = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                                score = 1.337, 
                                created_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                                updated_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                                is_guarantor = True, 
                                moral_guarantor = core.v2.models.moral_guarantor.MoralGuarantor(
                                    file_path = '', 
                                    type = '', 
                                    created_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                                    updated_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), ), 
                                meta = null, 
                                profile = '', 
                                completion_rate = 1.337, 
                                is_pre_application = True, 
                                pre_application_validated_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), )
                            ], 
                        moral_guarantor = core.v2.models.moral_guarantor.MoralGuarantor(
                            file_path = '', 
                            type = '', 
                            created_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                            updated_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), ), 
                        meta = null, 
                        profile = '', 
                        completion_rate = 1.337, 
                        is_pre_application = True, 
                        pre_application_validated_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), )
                    ],
                decision = 'PENDING',
                product = core.v2.models.list_products_projection.ListProductsProjection(
                    achived_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                    category = 'house', 
                    title = '', 
                    description = '', 
                    reference = '', 
                    available = True, 
                    availability = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                    exclusivity = True, 
                    disable_spontaneous_applications = True, 
                    managers = [
                        ''
                        ], 
                    meta = null, 
                    _id = '', 
                    tenant = '', 
                    created_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                    updated_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                    mandate_type = 'management', 
                    price = 1.337, 
                    fee = 1.337, 
                    fee_type = 'direct', 
                    photo = core.v2.models.product_photo.ProductPhoto(
                        _id = '5eb7cf5a86d9755df3a6c593', 
                        size = 56, 
                        path = '', 
                        filename = '', 
                        content_type = '', 
                        favorite = True, ), 
                    incoming_requests = 56, 
                    rent_amount = 1.337, 
                    monthly_charges = 1.337, 
                    furnished = True, 
                    warranty_amount = 1.337, 
                    agency_fees = 1.337, 
                    unpaid_rent_insurance = True, ),
                is_pre_application = True,
                pre_application_validated_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f')
            )
        else:
            return ListRentalFile(
                id = '',
        )
        """

    def testListRentalFile(self):
        """Test ListRentalFile"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)


if __name__ == "__main__":
    unittest.main()
