# coding: utf-8

"""
    Eazyrent core API

    EazyRent Core API ====================  Description -------------  The EazyRent API is a powerful tool, designed to automate and streamline the tenant application process for professionals in the real estate and insurance sectors.  Our API leverages advanced technologies like Optical Character Recognition (OCR) and Machine Learning to collect, analyze, and verify tenant application documents.  The API helps clients detect fraudulent submissions and assess the reliability of potential tenants, ensuring a secure and efficient tenant selection process.  Target Audience ----------------   * **Real Estate Agencies and Social Housing Providers:** Professionals who need a reliable solution to evaluate tenant applications quickly and accurately.   * **Rent Guarantee Insurers:** Companies seeking to verify the credibility of tenant applications and assess eligibility for rent payment guarantees.   Purpose --------  The purpose of the EazyRent API is to enable seamless interaction with our tenant application system. It allows clients to integrate our automated document collection, analysis, and verification capabilities directly into their own workflows. By using our API, businesses can streamline operations, reduce fraud risk, and make well-informed decisions in the tenant selection process.   How to use this API ---------------------  To start using the EazyRent API, please refer to our comprehensive online documentation, which includes detailed information on API endpoints, authentication, and integration examples. You can access the documentation [here](https://docs.eazyrent.fr). This resource will guide you through the steps needed to integrate our API into your existing systems and maximize its capabilities.  

    The version of the OpenAPI document: 2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from eazyrent.core.v2.api.rental_files_api import RentalFilesApi


class TestRentalFilesApi(unittest.TestCase):
    """RentalFilesApi unit test stubs"""

    def setUp(self) -> None:
        self.api = RentalFilesApi()

    def tearDown(self) -> None:
        pass

    def test_ask_analysis(self) -> None:
        """Test case for ask_analysis

        Ask analysis
        """
        pass

    def test_close_rental_file(self) -> None:
        """Test case for close_rental_file

        Close rental file
        """
        pass

    def test_create_rental_file(self) -> None:
        """Test case for create_rental_file

        Create rental file
        """
        pass

    def test_delete_rental_file(self) -> None:
        """Test case for delete_rental_file

        Delete rental file
        """
        pass

    def test_download_documents(self) -> None:
        """Test case for download_documents

        Download documents
        """
        pass

    def test_get_rental_file(self) -> None:
        """Test case for get_rental_file

        Get rental file
        """
        pass

    def test_get_rental_file_by_metadata(self) -> None:
        """Test case for get_rental_file_by_metadata

        Get rental file by metadata
        """
        pass

    def test_get_rental_file_history_events(self) -> None:
        """Test case for get_rental_file_history_events

        Get rental file history events
        """
        pass

    def test_get_rental_file_status(self) -> None:
        """Test case for get_rental_file_status

        Get rental file status
        """
        pass

    def test_get_rental_file_status_by_metadata(self) -> None:
        """Test case for get_rental_file_status_by_metadata

        Get rental file status by metadata
        """
        pass

    def test_invite_applicant(self) -> None:
        """Test case for invite_applicant

        Invite applicant
        """
        pass

    def test_list_rental_files(self) -> None:
        """Test case for list_rental_files

        List rental files
        """
        pass

    def test_partial_update_rental_file(self) -> None:
        """Test case for partial_update_rental_file

        Partial update rental file
        """
        pass

    def test_reopen_all_forms(self) -> None:
        """Test case for reopen_all_forms

        Reopen all forms
        """
        pass

    def test_reopen_applicant_form(self) -> None:
        """Test case for reopen_applicant_form

        Reopen applicant form
        """
        pass

    def test_update_rental_file(self) -> None:
        """Test case for update_rental_file

        Update rental file
        """
        pass

    def test_validate_pre_application(self) -> None:
        """Test case for validate_pre_application

        Validate pre application
        """
        pass


if __name__ == "__main__":
    unittest.main()
