# coding: utf-8

# flake8: noqa

"""
    Eazyrent IAM API

    EazyRent IAM API ==================  Description -------------  The EazyRent IAM API provides robust identity and access management capabilities, enabling efficient account management and permission controls across the platform. Tailored for the SaaS environment, this API allows administrators to handle user authentication, manage roles, and define permissions to secure access to various resources. By centralizing user accounts and access rules, the IAM API ensures a secure, organized, and scalable approach to managing tenant and staff permissions.  Target Audience ------------------   * **Real Estate Agencies and Social Housing Providers:** Organizations requiring a secure, structured way to manage access for staff and tenants, ensuring that only authorized users can access specific resources and functionalities.   * **Rent Guarantee Insurers:** Companies that need to manage and restrict access to sensitive information, allowing only certain roles to handle tenant verification and risk assessment data.  Purpose --------  The purpose of the EazyRent IAM API is to centralize identity and permission management for platform users. Through this API, businesses can handle account creation, manage user roles, assign permissions, and track access to critical resources, all while ensuring compliance and data security. This results in streamlined operations, allowing clients to configure role-based access in alignment with organizational policies and requirements.  How to use this API -----------------------  To start using the EazyRent IAM API, consult our detailed documentation, which provides information on authentication, endpoint definitions, and integration best practices. This documentation covers the steps required to manage user identities, roles, and permissions within your existing systems, ensuring secure and efficient access control across the platform.

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "1.0.0"

# import apis into sdk package
from eazyrent.iam.v1.api.organizations_api import OrganizationsApi
from eazyrent.iam.v1.api.public_api import PublicApi
from eazyrent.iam.v1.api.service_accounts_api import ServiceAccountsApi
from eazyrent.iam.v1.api.team_api import TeamApi
from eazyrent.iam.v1.api.user_grants_api import UserGrantsApi
from eazyrent.iam.v1.api.users_api import UsersApi

# import ApiClient
from eazyrent.iam.v1.api_response import ApiResponse
from eazyrent.iam.v1.api_client import ApiClient
from eazyrent.iam.v1.configuration import Configuration
from eazyrent.iam.v1.exceptions import OpenApiException
from eazyrent.iam.v1.exceptions import ApiTypeError
from eazyrent.iam.v1.exceptions import ApiValueError
from eazyrent.iam.v1.exceptions import ApiKeyError
from eazyrent.iam.v1.exceptions import ApiAttributeError
from eazyrent.iam.v1.exceptions import ApiException

# import models into sdk package
from eazyrent.iam.v1.models.alert_importance import AlertImportance
from eazyrent.iam.v1.models.app_notification_config import AppNotificationConfig
from eazyrent.iam.v1.models.base_alert_type import BaseAlertType
from eazyrent.iam.v1.models.change_password import ChangePassword
from eazyrent.iam.v1.models.create_organization import CreateOrganization
from eazyrent.iam.v1.models.create_user import CreateUser
from eazyrent.iam.v1.models.email_notification_config import EmailNotificationConfig
from eazyrent.iam.v1.models.external_references_value import ExternalReferencesValue
from eazyrent.iam.v1.models.http_validation_error import HTTPValidationError
from eazyrent.iam.v1.models.join_organization import JoinOrganization
from eazyrent.iam.v1.models.list_organization import ListOrganization
from eazyrent.iam.v1.models.list_user import ListUser
from eazyrent.iam.v1.models.logo import Logo
from eazyrent.iam.v1.models.notification_config import NotificationConfig
from eazyrent.iam.v1.models.organization import Organization
from eazyrent.iam.v1.models.parent_organization import ParentOrganization
from eazyrent.iam.v1.models.partial_update_user import PartialUpdateUser
from eazyrent.iam.v1.models.register_admin_org_serializer import (
    RegisterAdminOrgSerializer,
)
from eazyrent.iam.v1.models.register_organization_serializer import (
    RegisterOrganizationSerializer,
)
from eazyrent.iam.v1.models.register_serializer import RegisterSerializer
from eazyrent.iam.v1.models.response_get_my_user import ResponseGetMyUser
from eazyrent.iam.v1.models.service_account import ServiceAccount
from eazyrent.iam.v1.models.update_user_grants import UpdateUserGrants
from eazyrent.iam.v1.models.user import User
from eazyrent.iam.v1.models.user_config import UserConfig
from eazyrent.iam.v1.models.user_config_property_rent_subscriptions_inner import (
    UserConfigPropertyRentSubscriptionsInner,
)
from eazyrent.iam.v1.models.validation_error import ValidationError
from eazyrent.iam.v1.models.validation_error_loc_inner import ValidationErrorLocInner
