# coding: utf-8

"""
    Eazyrent IAM API

    EazyRent IAM API ==================  Description -------------  The EazyRent IAM API provides robust identity and access management capabilities, enabling efficient account management and permission controls across the platform. Tailored for the SaaS environment, this API allows administrators to handle user authentication, manage roles, and define permissions to secure access to various resources. By centralizing user accounts and access rules, the IAM API ensures a secure, organized, and scalable approach to managing tenant and staff permissions.  Target Audience ------------------   * **Real Estate Agencies and Social Housing Providers:** Organizations requiring a secure, structured way to manage access for staff and tenants, ensuring that only authorized users can access specific resources and functionalities.   * **Rent Guarantee Insurers:** Companies that need to manage and restrict access to sensitive information, allowing only certain roles to handle tenant verification and risk assessment data.  Purpose --------  The purpose of the EazyRent IAM API is to centralize identity and permission management for platform users. Through this API, businesses can handle account creation, manage user roles, assign permissions, and track access to critical resources, all while ensuring compliance and data security. This results in streamlined operations, allowing clients to configure role-based access in alignment with organizational policies and requirements.  How to use this API -----------------------  To start using the EazyRent IAM API, consult our detailed documentation, which provides information on authentication, endpoint definitions, and integration best practices. This documentation covers the steps required to manage user identities, roles, and permissions within your existing systems, ensuring secure and efficient access control across the platform.

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from eazyrent.iam.v1.api.organizations_api import OrganizationsApi


class TestOrganizationsApi(unittest.TestCase):
    """OrganizationsApi unit test stubs"""

    def setUp(self) -> None:
        self.api = OrganizationsApi()

    def tearDown(self) -> None:
        pass

    def test_change_logo(self) -> None:
        """Test case for change_logo

        Change logo
        """
        pass

    def test_create_linked_account(self) -> None:
        """Test case for create_linked_account

        Create linked account
        """
        pass

    def test_delete_logo(self) -> None:
        """Test case for delete_logo

        Delete logo
        """
        pass

    def test_get_alert_importance(self) -> None:
        """Test case for get_alert_importance

        Get alert importance
        """
        pass

    def test_get_external_references(self) -> None:
        """Test case for get_external_references

        Get external references
        """
        pass

    def test_join_organization(self) -> None:
        """Test case for join_organization

        Join organization
        """
        pass

    def test_leave_organization(self) -> None:
        """Test case for leave_organization

        Leave organization
        """
        pass

    def test_list_all_linked_account(self) -> None:
        """Test case for list_all_linked_account

        List all linked account
        """
        pass

    def test_my_organization(self) -> None:
        """Test case for my_organization

        My organization
        """
        pass

    def test_update_alert_importance(self) -> None:
        """Test case for update_alert_importance

        Update alert importance
        """
        pass

    def test_update_external_references(self) -> None:
        """Test case for update_external_references

        Update external references
        """
        pass


if __name__ == "__main__":
    unittest.main()
