# coding: utf-8

# flake8: noqa
"""
    Eazyrent products API

    EazyRent Products API ======================  Description ------------  The EazyRent Product API offers a comprehensive solution for managing rental and sale listings, including property details, media distribution, and data import capabilities. Designed for real estate professionals, this API allows users to create, update, and manage property listings efficiently while ensuring accurate data and broad market reach. With features to streamline listing distribution and import property data from other platforms, the Product API simplifies property management, helping agencies maintain up-to-date and comprehensive property portfolios.  Target Audience -----------------   * **Real Estate Agencies and Social Housing Providers:** Professionals who need a centralized system to manage property listings, including rental and sale offerings, media distribution, and data synchronization across various platforms.   * **Property Managers:** Organizations looking to efficiently organize and promote property listings, manage property details, and ensure accurate, consistent information across marketing channels.  Purpose ---------  The purpose of the EazyRent Product API is to enable streamlined property management within the EazyRent platform. By integrating this API, businesses can centralize their property data, automate distribution to marketing channels, and simplify the process of keeping listings updated. This provides agencies with a scalable, efficient way to manage property portfolios, ensuring quick, effective exposure to potential tenants and buyers.  How to use this API ---------------------  To get started with the EazyRent Product API, please refer to our comprehensive documentation for authentication details, endpoint descriptions, and integration guides. This resource will help you set up efficient property management workflows, from data import to listing updates and distribution, all accessible within your existing systems.

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


# import models into model package
from eazyrent.products.v1.models.address import Address
from eazyrent.products.v1.models.air_conditioning import AirConditioning
from eazyrent.products.v1.models.building_information import BuildingInformation
from eazyrent.products.v1.models.computed_column import ComputedColumn
from eazyrent.products.v1.models.create_for_rent_product_input import (
    CreateForRentProductInput,
)
from eazyrent.products.v1.models.create_for_rent_product_output import (
    CreateForRentProductOutput,
)
from eazyrent.products.v1.models.create_for_sale_product_input import (
    CreateForSaleProductInput,
)
from eazyrent.products.v1.models.create_for_sale_product_output import (
    CreateForSaleProductOutput,
)
from eazyrent.products.v1.models.csv_descriptor import CsvDescriptor
from eazyrent.products.v1.models.csv_params import CsvParams
from eazyrent.products.v1.models.descriptor import Descriptor
from eazyrent.products.v1.models.equipement import Equipement
from eazyrent.products.v1.models.for_rent_product import ForRentProduct
from eazyrent.products.v1.models.for_sales_product import ForSalesProduct
from eazyrent.products.v1.models.geo_object import GeoObject
from eazyrent.products.v1.models.http_validation_error import HTTPValidationError
from eazyrent.products.v1.models.internal_information import InternalInformation
from eazyrent.products.v1.models.json_descriptor import JsonDescriptor
from eazyrent.products.v1.models.json_params import JsonParams
from eazyrent.products.v1.models.list_for_rent_product import ListForRentProduct
from eazyrent.products.v1.models.list_for_sales_product import ListForSalesProduct
from eazyrent.products.v1.models.managers_eq import ManagersEq
from eazyrent.products.v1.models.mandate_type import MandateType
from eazyrent.products.v1.models.next import Next
from eazyrent.products.v1.models.paginated_response_union_list_for_rent_product_list_for_sales_product import (
    PaginatedResponseUnionListForRentProductListForSalesProduct,
)
from eazyrent.products.v1.models.paginated_response_union_list_for_rent_product_list_for_sales_product_results_inner import (
    PaginatedResponseUnionListForRentProductListForSalesProductResultsInner,
)
from eazyrent.products.v1.models.photo_column import PhotoColumn
from eazyrent.products.v1.models.pool_specification import PoolSpecification
from eazyrent.products.v1.models.previous import Previous
from eazyrent.products.v1.models.product import Product
from eazyrent.products.v1.models.product_photo import ProductPhoto
from eazyrent.products.v1.models.product_type import ProductType
from eazyrent.products.v1.models.property_facilities import PropertyFacilities
from eazyrent.products.v1.models.response_create_product import ResponseCreateProduct
from eazyrent.products.v1.models.response_get_product import ResponseGetProduct
from eazyrent.products.v1.models.response_partial_update_product import (
    ResponsePartialUpdateProduct,
)
from eazyrent.products.v1.models.response_update_product import ResponseUpdateProduct
from eazyrent.products.v1.models.response_validate_descriptor import (
    ResponseValidateDescriptor,
)
from eazyrent.products.v1.models.room_specification import RoomSpecification
from eazyrent.products.v1.models.security_facilities import SecurityFacilities
from eazyrent.products.v1.models.update_for_rent_product import UpdateForRentProduct
from eazyrent.products.v1.models.update_for_sale_product import UpdateForSaleProduct
from eazyrent.products.v1.models.update_product import UpdateProduct
from eazyrent.products.v1.models.validate_import200_response_inner import (
    ValidateImport200ResponseInner,
)
from eazyrent.products.v1.models.validation_error import ValidationError
from eazyrent.products.v1.models.validation_error_loc_inner import (
    ValidationErrorLocInner,
)
from eazyrent.products.v1.models.xml_descriptor import XmlDescriptor
from eazyrent.products.v1.models.xml_params import XmlParams
from eazyrent.products.v1.models.zip_descriptor import ZipDescriptor
from eazyrent.products.v1.models.zip_params import ZipParams
