# coding: utf-8

"""
    Eazyrent products API

    EazyRent Products API ======================  Description ------------  The EazyRent Product API offers a comprehensive solution for managing rental and sale listings, including property details, media distribution, and data import capabilities. Designed for real estate professionals, this API allows users to create, update, and manage property listings efficiently while ensuring accurate data and broad market reach. With features to streamline listing distribution and import property data from other platforms, the Product API simplifies property management, helping agencies maintain up-to-date and comprehensive property portfolios.  Target Audience -----------------   * **Real Estate Agencies and Social Housing Providers:** Professionals who need a centralized system to manage property listings, including rental and sale offerings, media distribution, and data synchronization across various platforms.   * **Property Managers:** Organizations looking to efficiently organize and promote property listings, manage property details, and ensure accurate, consistent information across marketing channels.  Purpose ---------  The purpose of the EazyRent Product API is to enable streamlined property management within the EazyRent platform. By integrating this API, businesses can centralize their property data, automate distribution to marketing channels, and simplify the process of keeping listings updated. This provides agencies with a scalable, efficient way to manage property portfolios, ensuring quick, effective exposure to potential tenants and buyers.  How to use this API ---------------------  To get started with the EazyRent Product API, please refer to our comprehensive documentation for authentication details, endpoint descriptions, and integration guides. This resource will help you set up efficient property management workflows, from data import to listing updates and distribution, all accessible within your existing systems.

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from eazyrent.products.v1.models.response_get_product import ResponseGetProduct


class TestResponseGetProduct(unittest.TestCase):
    """ResponseGetProduct unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> ResponseGetProduct:
        """Test ResponseGetProduct
        include_optional is a boolean, when False only required
        params are included, when True both required and
        optional params are included"""
        # uncomment below to create an instance of `ResponseGetProduct`
        """
        model = ResponseGetProduct()
        if include_optional:
            return ResponseGetProduct(
                achived_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'),
                category = 'house',
                title = '',
                description = '',
                reference = '',
                available = True,
                availability = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(),
                exclusivity = True,
                disable_spontaneous_applications = True,
                managers = [
                    ''
                    ],
                meta = None,
                address = products.v1.models.address.Address(
                    street = '', 
                    city = '', 
                    state = '', 
                    zip_code = '', 
                    country = '', 
                    location = products.v1.models.geo_object.GeoObject(
                        type = 'Point', 
                        coordinates = [
                            null
                            ], 
                        format = 'EPSG:2154', ), ),
                owner = '',
                building_information = products.v1.models.building_information.BuildingInformation(
                    construction_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                    renovation_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                    energy_grade = '', 
                    surface = 1.337, 
                    floor = 56, 
                    floors = 0.0, 
                    heating_system = 'other', 
                    rooms = [
                        products.v1.models.room_specification.RoomSpecification(
                            name = '', 
                            surface = 1.337, 
                            orientation = '', 
                            type = '', 
                            floor = 56, )
                        ], ),
                property_facilities = products.v1.models.property_facilities.PropertyFacilities(
                    air_conditioning = products.v1.models.air_conditioning.AirConditioning(
                        installation_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                        split_number = 56, 
                        units_number = 56, 
                        last_maintenance_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), ), 
                    pool = products.v1.models.pool_specification.PoolSpecification(
                        type = 'in-ground', 
                        length = 1.337, 
                        width = 1.337, 
                        depth = 1.337, 
                        shape = '', 
                        materials = '', 
                        heating_system = '', 
                        construction_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                        indoor = True, 
                        safety_compliance = True, ), 
                    garage = [
                        products.v1.models.room_specification.RoomSpecification(
                            name = '', 
                            surface = 1.337, 
                            orientation = '', 
                            type = '', 
                            floor = 56, )
                        ], 
                    terraces = [
                        products.v1.models.room_specification.RoomSpecification(
                            name = '', 
                            surface = 1.337, 
                            orientation = '', 
                            type = '', 
                            floor = 56, )
                        ], 
                    cellars = [
                        
                        ], 
                    gardens = [
                        
                        ], 
                    internet_access = 'unknown', 
                    others = [
                        products.v1.models.equipement.Equipement(
                            name = '', 
                            description = '', )
                        ], 
                    intercom = True, 
                    elevator = True, 
                    parking = 56, 
                    security_facilities = products.v1.models.security_facilities.SecurityFacilities(
                        concierge = True, 
                        security_guard = True, 
                        camera = True, 
                        alarm_system = True, 
                        armored_door = True, ), ),
                internal_information = products.v1.models.internal_information.InternalInformation(
                    access_code = '', 
                    note = '', ),
                mandate_type = 'sales',
                rent_amount = 1.337,
                monthly_charges = 1.337,
                furnished = True,
                warranty_amount = 1.337,
                agency_fees = 1.337,
                unpaid_rent_insurance = True,
                id = '',
                tenant = '',
                created_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'),
                updated_at = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'),
                photo = products.v1.models.product_photo.ProductPhoto(
                    _id = '5eb7cf5a86d9755df3a6c593', 
                    size = 56, 
                    path = '', 
                    filename = '', 
                    content_type = '', 
                    favorite = True, ),
                price = 1.337,
                fee = 1.337,
                fee_type = 'direct'
            )
        else:
            return ResponseGetProduct(
                tenant = '',
        )
        """

    def testResponseGetProduct(self):
        """Test ResponseGetProduct"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)


if __name__ == "__main__":
    unittest.main()
